## gpsd 3.25

=== SConstruct ===
""" SCons build recipe for the GPSD project

Important targets:

build      - build the software (default)
dist       - make distribution tarballs .gz and .xz, plus .zip
zip        - make distribution zip
install    - install programs, libraries, and manual pages
uninstall  - undo an install

check      - run regression and unit tests.
audit      - run code-auditing tools
testbuild  - test-build the code from a tarball
website    - refresh the website
release    - ship a release

--clean    - clean all normal build targets
-c         - clean all normal build targets

Useful configuration options:
debug=yes     -- Compile and link with debugging options. Turns off
                 optimizations,
debug_opt=yes -- Compile and link with debugging options. Leaves on
                 optimizations,

Useful scons options:
--warn=all -- to see scons warnings

Setting the DESTDIR environment variable will prefix the install destinations
without changing the --prefix prefix.

Pretty much all this file does is create the variant_dir, and call SConscript.
"""

# Unfinished items:
# * Coveraging mode: gcc "-coverage" flag requires a hack
#   for building the python bindings

# This file is Copyright 2010 by the GPSD project
# SPDX-License-Identifier: BSD-2-clause
#
# This code runs compatibly under Python 2 and 3.x for x >= 2.
# Preserve this property!
from __future__ import print_function

import atexit      # for atexit.register()
import os

# gpsd needs Scons version at least 2.3
EnsureSConsVersion(2, 3, 0)
# gpsd needs Python version at least 2.6
EnsurePythonVersion(2, 6)

# package version
gpsd_version = "3.25"
# name 'build' is already taken, put stuff in gpsd-$VERSION
# it makes tar simple
variantdir = 'gpsd-' + gpsd_version

# one touch clean!
# also, for brutal effect, you can do: git clean -dfx
if GetOption('clean'):
    # .pages and .public are GitLab "pages".
    clean_targets = '%s buildtmp .public .pages testbuild' % variantdir
    atexit.register(lambda: os.system('rm -rf ' + clean_targets))

# Not everything respects this  chdir()
SConscriptChdir(1)
SConscript('SConscript',
           duplicate=1,
           exports=['gpsd_version', 'variantdir'],
           must_exit=True,
           variant_dir=variantdir,
           )
# VariantDir('buildtmp', '.')
# SConscript('buildtmp/SConscript', must_exit=True, duplicate=1)

=== debian/changelog ===
gpsd (3.25-3ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:36:20 +0000

gpsd (3.25-3ubuntu2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:31:08 +0000

gpsd (3.25-3ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Mark strlcat strlctpy as optional

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Feb 2024 17:11:50 +0100

gpsd (3.25-3) unstable; urgency=medium

  * Upload to unstable (Closes: #1063318)
  * Change build-dep on dpkg-dev to avoid bad backports
  * wrap-and-sort control files
  * Remove makedev from build-dep (Closes: #986713)
  * Install systemd service files in /usr (Closes: #1059185)

 -- Boian Bonev <bbonev@ipacct.com>  Wed, 28 Feb 2024 16:16:30 +0000

gpsd (3.25-3~exp1) experimental; urgency=medium

  * Fix a typo in d/rules
  * Convert lintian overrides to templates
  * Fix a typo in lintian overrides
  * Replace obsolete pkg-config w/ pkgconf
  * Update copyright years

 -- Boian Bonev <bbonev@ipacct.com>  Sun, 11 Feb 2024 13:30:56 +0000

gpsd (3.25-2.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Steve Langasek <vorlon@debian.org>  Tue, 06 Feb 2024 05:50:03 +0000

gpsd (3.25-2ubuntu2) mantic; urgency=medium

  * Mark strlcat strlctpy as optional

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 12 Sep 2023 09:40:59 +0200

gpsd (3.25-2) unstable; urgency=medium

  [ Boian Bonev ]
  * Refresh patches
  * Fix the second instance of 067b:2303 (Closes: #884744, LP: #2012207)

  [ Adrian Bunk ]
  * Don't build depend on python3-gps

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 11 Sep 2023 15:47:57 +0000

gpsd (3.25-1) unstable; urgency=medium

  * Upload to sid

 -- Boian Bonev <bbonev@ipacct.com>  Wed, 28 Jun 2023 21:37:43 +0000

gpsd (3.25-1~exp2) experimental; urgency=medium

  * Add patch for upstream fix for build on Hurd

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 24 Jun 2023 19:59:21 +0000

gpsd (3.25-1~exp1) experimental; urgency=medium

  [ Bernd Zeimetz ]
  ** SNAPSHOT build @133003725db331160722e54738bfb6b52bb0e501 **

  * [da10dc6b] New upstream version 3.22
  * [c09c5182] New upstream version 3.23.1
  * [02c4d4ea] Refreshing patches
  * [56072ace] snapshot changelog
  * [4fe064ce] remove gpssnmp for now.
    Unknown oid being used.
  * [6c251561] Install gpsdebuginfo.

  [ Boian Bonev ]
  * New maintainer (Closes: #1034532)
  * New upstream version 3.25
  * Refresh patches
  * Add patch fixing spelling
  * Add upstream metadata
  * Do not install libgpsdpacket.so symlink
  * Install gpsinit
  * Add patch fixing encoding/keywords in .desktop files
  * Enable hardening flags in the build
  * Enable parallel build
  * Override lintian false positives
  * Remove x bit from gps.py, __init__.py, packet.py and skyview.php
  * State RRR=no
  * Bump up standards to 4.6.2, no changes
  * Update homepage to gpsd.io
  * Install gpssnmp and MIB file in gpsd-tools
  * Add contact in d/copyright
  * Mark libqgpsmm-dev MA same
  * Update copyright to new license BSD-2-clause
    re-check all files with different copyright

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 05 Jun 2023 00:20:49 +0000

gpsd (3.22-4.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Christian Ehrhardt ]
  * [17606570] d/p/gpsmon-gpsmon.c-Fix-silly-warning.patch: fix FTFBS
    (Closes: #997178)

 -- Paul Gevers <elbrus@debian.org>  Sun, 11 Sep 2022 16:45:05 +0200

=== debian/control ===
Source: gpsd
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Boian Bonev <bbonev@ipacct.com>
Build-Depends:
 asciidoc,
 asciidoctor,
 bc,
 debhelper-compat (= 13),
 dh-apparmor,
 dh-buildinfo,
 dh-exec,
 dh-python,
 docbook-xml,
 docbook-xsl,
 dpkg-dev (>= 1.22.5),
 gir1.2-gtk-3.0,
 libbluetooth-dev [linux-any],
 libdbus-1-dev,
 libdbus-glib-1-dev,
 libglib2.0-dev,
 libncurses-dev,
 libsystemd-dev [linux-any],
 libudev-dev [linux-any],
 libusb-1.0-0-dev,
 lsb-release,
 pkgconf,
 po-debconf,
 pps-tools (>= 0.20120406+g0deb9c7e-2~) [linux-any],
 python3-all-dbg (>= 2.6.6-3),
 python3-all-dev (>= 2.6.6-3),
 python3-cairo,
 python3-gi,
 python3-gi-cairo,
 python3-matplotlib,
 python3-serial,
 qtbase5-dev,
 scons (>= 3.0.1-2~),
 xsltproc,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gpsd.io
Vcs-Browser: https://salsa.debian.org/debian-gps-team/pkg-gpsd/
Vcs-Git: https://salsa.debian.org/debian-gps-team/pkg-gpsd.git

Package: gpsd
Architecture: any
Depends:
 adduser (>= 3.34),
 libgps30t64 (= ${binary:Version}),
 netbase | systemd-sysv,
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 gpsd-tools,
 udev [linux-any],
Breaks:
 gpsd-clients (<< 3.20-9),
 gpsd-tools (<< 3.20-10),
 ${gpsd:Breaks},
Replaces:
 gpsd-clients (<< 3.20-9),
 gpsd-tools (<< 3.20-10),
Suggests:
 apparmor,
 dbus,
 gpsd-clients,
Conflicts:
 fso-gpsd,
Multi-Arch: foreign
Description: Global Positioning System - daemon
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 With gpsd, multiple GPS client applications can share access to devices
 without contention or loss of data. Also, gpsd responds to queries with a
 format that is substantially easier to parse than the different standards
 emitted by GPS devices.
 .
 This also includes common tools ubxtool and gpsctl for device configuration
 of the local hardware as well as a ntpshmmon to check generated refclock data.

Package: gpsd-clients
Architecture: any
Depends:
 gir1.2-gtk-3.0,
 gpsd-tools (= ${binary:Version}),
 libgps30t64 (= ${binary:Version}),
 python3,
 python3-cairo,
 python3-gi,
 python3-gi-cairo,
 python3-gps,
 python3-matplotlib,
 python3-serial,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 gpsd,
Breaks:
 gpsd-tools (<< 3.20-10),
 python-gps,
Replaces:
 gpsd-tools (<< 3.20-10),
 python-gps,
Description: Global Positioning System - clients
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains auxiliary tools and example clients for monitoring,
 testing, latency-profiling, device configuration and simulating gpsd.

Package: gpsd-tools
Architecture: any
Depends:
 libgps30t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 gpsd,
Breaks:
 gpsd (<< 3.20-9),
 gpsd-clients (<< 3.20-10),
 python-gps,
Replaces:
 gpsd-clients (<< 3.20-10),
 python-gps,
Description: Global Positioning System - tools
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the most common tools 'gpsmon' and 'cgps' used to
 access a GPS device.

Package: libgps-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libgps30t64 (= ${binary:Version}),
 pkgconf,
 ${misc:Depends},
Description: Global Positioning System - development files
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the header and development files needed to build
 programs and packages using libgps.

Package: libgps30t64
Provides:
 ${t64:Provides},
Replaces:
 libgps30,
Breaks:
 libgps30 (<< ${source:Version}),
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 gpsd,
Conflicts:
 fso-gpsd,
Pre-Depends:
 ${misc:Pre-Depends},
Description: Global Positioning System - library
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libgps, a C service library for querying GPS
 devices. It supports both a low-level interface, which communicates
 directly with the device to which the GPS is connected, and a high-level
 interface, which goes through gpsd and is intended for concurrent use by
 several applications.

Package: libqgpsmm-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libgps-dev (= ${binary:Version}),
 libqgpsmm30t64 (= ${binary:Version}),
 pkgconf,
 ${misc:Depends},
Description: Global Positioning System - Qt wrapper for libgps (development)
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides the development file for libQgpsmm, the Qt version of
 libgpsmm. It contains pkgconfig and qmake bits to build with the library.

Package: libqgpsmm30t64
Provides:
 ${t64:Provides},
Replaces:
 libqgpsmm30,
Breaks:
 libqgpsmm30 (<< ${source:Version}),
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: Global Positioning System - Qt wrapper for libgps
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libQgpsmm, the Qt version of libgpsmm.
 It is a wrapper over libgps, the service library for querying GPS
 devices. libQgpsmm is available on all platforms which are supported
 by Qt4.

Package: python3-gps
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 gpsd,
Provides:
 ${python3:Provides},
Breaks:
 ${python3:Breaks},
Description: Global Positioning System - Python 3 libraries
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains a Python 3 interface to connect to gpsd, together with
 a module providing a controlled testing environment.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

#uncomment if debhelper should be verbose
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConscript | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))
LIBGPS_PKG_SUFFIX := $(LIBGPS_SONAME)t64

export QT_SELECT=qt5

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS := 1
endif

LIBGPS_DEBIAN_FILE_SOURCES := $(strip $(shell ls -1 debian/*LIBGPSSONAME* ))
LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_PKG_SUFFIX),g'))

#python versions
PYTHON3 := python3

#debhelper version and settings needed for udev
DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')
LSB_RELEASE := $(shell lsb_release -si)
UDEV_BREAKS =

ifeq (Debian,$(strip $(LSB_RELEASE))) ## debian ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.3.15; echo $$?)))
UDEV_BREAKS = 125
endif
else ## not debian ##
ifeq (Ubuntu,$(strip $(LSB_RELEASE))) ## ubuntu ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.0.17ubuntu2; echo $$?)))
UDEV_BREAKS = 136-1
endif
endif ## ubuntu ##
endif ## debian ##

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SCONSOPTS = \
	prefix=/usr \
	systemd=yes \
	nostrip=yes \
	dbus_export=yes \
	docdir=/usr/share/doc/gpsd \
	libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	gpsd_user=gpsd \
	gpsd_group=dialout \
	qt_versioned=5 \
	python_libdir=/usr/lib/python3/dist-packages

ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += manbuild=no
else
	SCONSOPTS += manbuild=yes
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += debug=yes
else
	SCONSOPTS += debug=no
endif

#package names
PACKAGE_GPSD := gpsd
PACKAGE_CLIENTS := gpsd-clients
PACKAGE_TOOLS := gpsd-tools
PACKAGE_LIB := libgps$(LIB_soname)
PACKAGE_QTLIB := libqgpsmm$(LIB_soname)
PACKAGE_LIB_DEV := libgps-dev
PACKAGE_QTLIB_DEV := libqgpsmm-dev
PACKAGE_PY3 := python3-gps


cflags := $(shell DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags --get CFLAGS)
cppflags := $(shell DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags --get CPPFLAGS)
cxxflags := $(shell DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags --get CXXFLAGS)
ldflags := $(shell DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags --get LDFLAGS)

SCONS_ENV := set -e ;\
		export LDFLAGS="$(ldflags)" ;\
		export CFLAGS="$(cflags)" ;\
		export CXXFLAGS="$(cxxflags)" ;\
		export CPPFLAGS="$(cppflags)";


$(LIBGPS_DEBIAN_FILE_TARGETS): $(LIBGPS_DEBIAN_FILE_SOURCES)
	for source in $(LIBGPS_DEBIAN_FILE_SOURCES); do \
		target=$$(echo "$$source" | sed 's,LIBGPSSONAME,$(LIBGPS_PKG_SUFFIX),g') ;\
		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g; s,LIBGPS_PKG_SUFFIX,$(LIBGPS_PKG_SUFFIX),g' "$$source" > "$$target" ;\
	done

debian/control: debian/control.in
		rm -f $@
		sed 's,LIBGPS_PKG_SUFFIX,$(LIBGPS_PKG_SUFFIX),g' $< > $@
		-if which git 1>/dev/null && [ -d .git ]; then \
			git add debian/control ;\
			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
		fi ;\

SConscript.deb_revision: SConscript
	if [ ! -f $@ ]; then \
		cp $< $@ ;\
		sed -i '/^revision=/s/%(.*)/%("$(DEB_VERSION)",)/' $< ;\
	fi
	touch $@

build-indep: build
build-arch: build

build: build-stamp
build-stamp: SConscript.deb_revision build-static-stamp
	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons shared=yes $(SCONSOPTS) target_python=$(PYTHON3) -j$(NUMJOBS)
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# disable tests on hurd due to weird ipv6 errors
	# http://deb.li/4C46AEAC.7040906@bzed.de
ifeq (,$(findstring hurd,$(DEB_HOST_ARCH_OS)))

	# remove those binary tests we can't patch with quilt.
	rm -f test/daemon/garmin18x-bin.log
	rm -f test/daemon/sirfstarv.log
	rm -f test/daemon/trimble-lasseniq-bin2d.log
	rm -f test/daemon/ublox-ned-m8t-sbfrx3.log
	rm -f test/daemon/ublox-neo-m8t-s.log
	rm -f test/daemon/ublox-neo-m8t.log
	rm -f test/daemon/ublox-zed-f9p-hp.log
	rm -f test/daemon/ublox-zed-f9p_hpg1.11.log
	rm -f test/daemon/ublox-zed-f9t-rtcm3.log

	-$(SCONS_ENV) $(PYTHON3) /usr/bin/scons check -j$(NUMJOBS)
endif
endif
	touch $@

build-static-stamp: SConscript.deb_revision
	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons shared=no $(SCONSOPTS) target_python=$(PYTHON3) -j$(NUMJOBS)
	cp gpsd-*/libgps.a libgps.a
	rm -rf gpsd-*
	touch $@

clean: debian/control
	dh_testdir
	dh_testroot
	# revert revision changes in SConscript
	if [ -f SConscript.deb_revision ]; then \
		mv SConscript.deb_revision SConscript; \
	fi
	dh_clean
	rm -rf \
		buildtmp \
		gpsd-* \
		.sconf_temp \
		.scons-option-cache \
		.sconsign.dblite \
		.sconsign.*.dblite \
		gps/*.pyc \
		TROUBLESHOOTING \
		debian/buildinfo.gz \
		config.log \
		debian/shlibs.local \
		leapsecond.pyc \
		libgps.a \
		$(LIBGPS_DEBIAN_FILE_TARGETS) \
		__pycache__
: install-stamp
install-stamp: build-stamp build-static-stamp $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_testdir
	dh_testroot
	dh_prep
	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp $(PYTHON3) /usr/bin/scons install $(SCONSOPTS) target_python=$(PYTHON3)
	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp $(PYTHON3) /usr/bin/scons systemd_install $(SCONSOPTS) target_python=$(PYTHON3)
	# install static lib
	cp libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	cp INSTALL.adoc TROUBLESHOOTING.adoc
	# we collect our own documentation
	rm -rf debian/tmp/usr/share/doc/gpsd
	# move systemd control files to /usr because scons does not honor systemd.pc pkg-config data
	mkdir -p debian/tmp/usr/lib/systemd/system
	mv debian/tmp/lib/systemd/system/gpsd.service debian/tmp/usr/lib/systemd/system/gpsd.service
	mv debian/tmp/lib/systemd/system/gpsd.socket debian/tmp/usr/lib/systemd/system/gpsd.socket
	mv debian/tmp/lib/systemd/system/gpsdctl@.service debian/tmp/usr/lib/systemd/system/gpsdctl@.service
	# install everything
	dh_install
	# quirk to avoid issues by broken fakeroot misdetecting links as files and
	# then breaking dh_install -> cp -a fatally
	ln -s libgps.so.$(LIBGPS_SONAME).0.0 debian/libgps$(LIBGPS_PKG_SUFFIX)/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
	# these files do not need to be executable
	chmod -x debian/gpsd-clients/usr/share/doc/gpsd-clients/examples/skyview.php
	chmod -x debian/$(PACKAGE_PY3)/usr/lib/python3*/*-packages/gps/__init__.py
	chmod -x debian/$(PACKAGE_PY3)/usr/lib/python3*/*-packages/gps/packet.py
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
	dh_missing --fail-missing
	touch $@
: install
install-arch: install

binary: install-stamp
	dh_testdir
	dh_testroot
	dh_installchangelogs  NEWS
	dh_installdocs
	dh_installman
	dh_installmenu
	dh_apparmor --profile-name=usr.sbin.gpsd -pgpsd
	dh_installsystemd -pgpsd --restart-after-upgrade gpsdctl@.service gpsd.socket
	dh_installsystemd -pgpsd --no-enable --no-start gpsd.service
	dh_installinit --no-start
	dh_installsystemd -pgpsd --restart-after-upgrade
	chmod 644 debian/$(PACKAGE_PY3)/usr/lib/python3*/*-packages/gps/gps.py
	dh_python3 -Ngpsd-clients
	dh_python3 -pgpsd-clients usr/bin
	dh_python3 -pgpsd lib/udev/
	cp $(CURDIR)/gpsd-*/gpsd.rules $(CURDIR)/debian/gpsd.udev
	dh_installudev
	dh_link
	dh_strip
	dh_compress
	dh_fixperms  -Xgpsd.hotplug
	dh_lintian
ifeq (,$(DEB_BUILD_OPTIONS))
	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_PKG_SUFFIX) -- -c4
	dh_makeshlibs -plibqgpsmm$(LIBGPS_PKG_SUFFIX) -- -c1
else
	dh_makeshlibs
endif
	dh_shlibdeps
ifneq (,$(UDEV_BREAKS))
	echo "gpsd:Breaks=udev (<< $(UDEV_BREAKS))" >> $(CURDIR)/debian/gpsd.substvars
endif
	dh_gencontrol
	dh_installdeb
	dh_md5sums
	dh_builddeb


binary-indep: binary
binary-arch: binary

.PHONY: binary binary-indep binary-arch \
	install install-arch install-indep \
	clean \
	build debian/control

=== debian/tests/control ===
Tests: check-service
Depends:
 coreutils,
 gpsd,
 grep,
 systemd,
 telnet,
Restrictions: needs-root, isolation-container

=== debian/watch ===
version=4

opts=pgpsigurlmangle=s/$/.sig/ https://download-mirror.savannah.gnu.org/releases/gpsd/gpsd-(.*).tar.gz

## gpsd 3.26.1

=== debian/changelog ===
gpsd (3.26.1-1) unstable; urgency=medium

  [ наб ]
  * Remove dh-buildinfo

  [ Boian Bonev ]
  * Add patch from Alexander Inyukhin
    <shurick@sectorb.msk.ru> (Closes: #1063331)
  * New upstream version 3.26.1
  * Refresh patches and remove the bits applied upstream
  * Remove Rules-Requires-Root: no
  * Complete the t64 transition
  * Update shared library symbols
  * Add BD: ruby-rouge for asciidoctor
  * Update d/watch to v5
  * Bump standards to 4.7.2, no changes

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 04 Nov 2025 21:28:21 +0000

gpsd (3.25-5) unstable; urgency=medium

  * Fix apparmor profile to work on usrmerged systems too (Closes: #1093437)
  * Add build-dep on python3-setuptools (Closes: #1080885)
  * Bump standards to 4.7.0, no changes
  * Remove the unused lintian overrides
  * Update debian copyright year

 -- Boian Bonev <bbonev@ipacct.com>  Sun, 19 Jan 2025 16:06:33 +0000

gpsd (3.25-4) unstable; urgency=medium

  * Mark strlcat/strlcpy as MISSING in .sybmols (Closes: #1071311)

 -- Boian Bonev <bbonev@ipacct.com>  Thu, 23 May 2024 20:36:33 +0000

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,18 @@
 Source: gpsd
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Boian Bonev <bbonev@ipacct.com>
+Maintainer: Boian Bonev <bbonev@ipacct.com>
 Build-Depends:
+ debhelper-compat (= 13),
+ dh-apparmor,
+ dh-exec,
+ dh-python,
+ dpkg-dev (>= 1.22.5),
  asciidoc,
  asciidoctor,
  bc,
- debhelper-compat (= 13),
- dh-apparmor,
- dh-buildinfo,
- dh-exec,
- dh-python,
  docbook-xml,
  docbook-xsl,
- dpkg-dev (>= 1.22.5),
  gir1.2-gtk-3.0,
  libbluetooth-dev [linux-any],
  libdbus-1-dev,
@@ -35,11 +33,12 @@
  python3-gi-cairo,
  python3-matplotlib,
  python3-serial,
+ python3-setuptools,
  qtbase5-dev,
+ ruby-rouge,
  scons (>= 3.0.1-2~),
  xsltproc,
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://gpsd.io
 Vcs-Browser: https://salsa.debian.org/debian-gps-team/pkg-gpsd/
 Vcs-Git: https://salsa.debian.org/debian-gps-team/pkg-gpsd.git
@@ -48,7 +47,7 @@
 Architecture: any
 Depends:
  adduser (>= 3.34),
- libgps30t64 (= ${binary:Version}),
+ libgps31 (= ${binary:Version}),
  netbase | systemd-sysv,
  python3,
  ${misc:Depends},
@@ -89,7 +88,7 @@
 Depends:
  gir1.2-gtk-3.0,
  gpsd-tools (= ${binary:Version}),
- libgps30t64 (= ${binary:Version}),
+ libgps31 (= ${binary:Version}),
  python3,
  python3-cairo,
  python3-gi,
@@ -119,7 +118,7 @@
 Package: gpsd-tools
 Architecture: any
 Depends:
- libgps30t64 (= ${binary:Version}),
+ libgps31 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Suggests:
@@ -144,7 +143,7 @@
 Section: libdevel
 Multi-Arch: same
 Depends:
- libgps30t64 (= ${binary:Version}),
+ libgps31 (= ${binary:Version}),
  pkgconf,
  ${misc:Depends},
 Description: Global Positioning System - development files
@@ -155,13 +154,7 @@
  This package contains the header and development files needed to build
  programs and packages using libgps.
 
-Package: libgps30t64
-Provides:
- ${t64:Provides},
-Replaces:
- libgps30,
-Breaks:
- libgps30 (<< ${source:Version}),
+Package: libgps31
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -191,7 +184,7 @@
 Multi-Arch: same
 Depends:
  libgps-dev (= ${binary:Version}),
- libqgpsmm30t64 (= ${binary:Version}),
+ libqgpsmm31 (= ${binary:Version}),
  pkgconf,
  ${misc:Depends},
 Description: Global Positioning System - Qt wrapper for libgps (development)
@@ -202,13 +195,7 @@
  This package provides the development file for libQgpsmm, the Qt version of
  libgpsmm. It contains pkgconfig and qmake bits to build with the library.
 
-Package: libqgpsmm30t64
-Provides:
- ${t64:Provides},
-Replaces:
- libqgpsmm30,
-Breaks:
- libqgpsmm30 (<< ${source:Version}),
+Package: libqgpsmm31
 Architecture: any
 Section: libs
 Depends:

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,6 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConscript | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))
-LIBGPS_PKG_SUFFIX := $(LIBGPS_SONAME)t64
 
 export QT_SELECT=qt5
 
@@ -18,7 +17,7 @@
 endif
 
 LIBGPS_DEBIAN_FILE_SOURCES := $(strip $(shell ls -1 debian/*LIBGPSSONAME* ))
-LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_PKG_SUFFIX),g'))
+LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g'))
 
 #python versions
 PYTHON3 := python3
@@ -91,13 +90,13 @@
 
 $(LIBGPS_DEBIAN_FILE_TARGETS): $(LIBGPS_DEBIAN_FILE_SOURCES)
 	for source in $(LIBGPS_DEBIAN_FILE_SOURCES); do \
-		target=$$(echo "$$source" | sed 's,LIBGPSSONAME,$(LIBGPS_PKG_SUFFIX),g') ;\
-		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g; s,LIBGPS_PKG_SUFFIX,$(LIBGPS_PKG_SUFFIX),g' "$$source" > "$$target" ;\
+		target=$$(echo "$$source" | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g') ;\
+		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' "$$source" > "$$target" ;\
 	done
 
 debian/control: debian/control.in
 		rm -f $@
-		sed 's,LIBGPS_PKG_SUFFIX,$(LIBGPS_PKG_SUFFIX),g' $< > $@
+		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@
 		-if which git 1>/dev/null && [ -d .git ]; then \
 			git add debian/control ;\
 			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
@@ -160,7 +159,6 @@
 		.sconsign.*.dblite \
 		gps/*.pyc \
 		TROUBLESHOOTING \
-		debian/buildinfo.gz \
 		config.log \
 		debian/shlibs.local \
 		leapsecond.pyc \
@@ -188,7 +186,7 @@
 	dh_install
 	# quirk to avoid issues by broken fakeroot misdetecting links as files and
 	# then breaking dh_install -> cp -a fatally
-	ln -s libgps.so.$(LIBGPS_SONAME).0.0 debian/libgps$(LIBGPS_PKG_SUFFIX)/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
+	ln -s libgps.so.$(LIBGPS_SONAME).0.0 debian/libgps$(LIBGPS_SONAME)/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
 	# these files do not need to be executable
 	chmod -x debian/gpsd-clients/usr/share/doc/gpsd-clients/examples/skyview.php
 	chmod -x debian/$(PACKAGE_PY3)/usr/lib/python3*/*-packages/gps/__init__.py
@@ -223,8 +221,8 @@
 	dh_fixperms  -Xgpsd.hotplug
 	dh_lintian
 ifeq (,$(DEB_BUILD_OPTIONS))
-	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_PKG_SUFFIX) -- -c4
-	dh_makeshlibs -plibqgpsmm$(LIBGPS_PKG_SUFFIX) -- -c1
+	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_SONAME) -- -c4
+	dh_makeshlibs -plibqgpsmm$(LIBGPS_SONAME) -- -c1
 else
 	dh_makeshlibs
 endif

=== debian/watch ===
Version: 5

Source: https://download-mirror.savannah.gnu.org/releases/gpsd/
Matching-Pattern: gpsd-(.*).tar.[xg]z
Pgpsigurlmangle: s/$/.sig/

## gpsd 3.27

=== SConstruct ===
--- 
+++ 
@@ -52,7 +52,7 @@
 EnsurePythonVersion(2, 6)
 
 # package version
-gpsd_version = "3.25"
+gpsd_version = "3.27"
 # name 'build' is already taken, put stuff in gpsd-$VERSION
 # it makes tar simple
 variantdir = 'gpsd-' + gpsd_version

=== debian/changelog ===
gpsd (3.27-1.1ubuntu1) resolute; urgency=medium

  * SECURITY UPDATE: heap OOB write in NMEA2000 PGN 129540 driver
    - debian/patches/CVE-2025-67268.patch: fix skyview buffer overrun in
      drivers/driver_nmea2000.c.
    - CVE-2025-67268
  * SECURITY UPDATE: integer underflow when parsing a NAVCOM packet
    - debian/patches/CVE-2025-67269.patch: fix integer underflow in
      malicious Navcom packet in gpsd/packet.c.
    - CVE-2025-67269

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 06 Jan 2026 13:32:53 -0500

gpsd (3.27-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Move to unstable

 -- Bastian Germann <bage@debian.org>  Thu, 27 Nov 2025 11:01:50 +0100

gpsd (3.27-1) experimental; urgency=medium

  * New upstream version 3.27

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 25 Nov 2025 20:07:05 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: gpsd
 Section: misc
 Priority: optional
-Maintainer: Boian Bonev <bbonev@ipacct.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Boian Bonev <bbonev@ipacct.com>
 Build-Depends:
  debhelper-compat (= 13),
  dh-apparmor,
@@ -47,7 +48,7 @@
 Architecture: any
 Depends:
  adduser (>= 3.34),
- libgps31 (= ${binary:Version}),
+ libgps32 (= ${binary:Version}),
  netbase | systemd-sysv,
  python3,
  ${misc:Depends},
@@ -88,7 +89,7 @@
 Depends:
  gir1.2-gtk-3.0,
  gpsd-tools (= ${binary:Version}),
- libgps31 (= ${binary:Version}),
+ libgps32 (= ${binary:Version}),
  python3,
  python3-cairo,
  python3-gi,
@@ -118,7 +119,7 @@
 Package: gpsd-tools
 Architecture: any
 Depends:
- libgps31 (= ${binary:Version}),
+ libgps32 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Suggests:
@@ -143,7 +144,7 @@
 Section: libdevel
 Multi-Arch: same
 Depends:
- libgps31 (= ${binary:Version}),
+ libgps32 (= ${binary:Version}),
  pkgconf,
  ${misc:Depends},
 Description: Global Positioning System - development files
@@ -154,7 +155,7 @@
  This package contains the header and development files needed to build
  programs and packages using libgps.
 
-Package: libgps31
+Package: libgps32
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -184,7 +185,7 @@
 Multi-Arch: same
 Depends:
  libgps-dev (= ${binary:Version}),
- libqgpsmm31 (= ${binary:Version}),
+ libqgpsmm32 (= ${binary:Version}),
  pkgconf,
  ${misc:Depends},
 Description: Global Positioning System - Qt wrapper for libgps (development)
@@ -195,7 +196,7 @@
  This package provides the development file for libQgpsmm, the Qt version of
  libgpsmm. It contains pkgconfig and qmake bits to build with the library.
 
-Package: libqgpsmm31
+Package: libqgpsmm32
 Architecture: any
 Section: libs
 Depends:

## gpsd 3.27.5

=== SConstruct ===
--- 
+++ 
@@ -52,7 +52,7 @@
 EnsurePythonVersion(2, 6)
 
 # package version
-gpsd_version = "3.27"
+gpsd_version = "3.27.5"
 # name 'build' is already taken, put stuff in gpsd-$VERSION
 # it makes tar simple
 variantdir = 'gpsd-' + gpsd_version

=== debian/changelog ===
gpsd (3.27.5-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version
  * Fix CVE-2025-67268 (Closes: #1124800).
    gpsd contains a heap-based out-of-bounds write
    vulnerability in the drivers/driver_nmea2000.c file.
    The hnd_129540 function, which handles NMEA2000 PGN 129540
    (GNSS Satellites in View) packets, fails to validate the
    user-supplied satellite count against the size of the skyview
    array (184 elements). This allows an attacker to write beyond
    the bounds of the array by providing a satellite count up
    to 255, leading to memory corruption, Denial of Service (DoS),
    and potentially arbitrary code execution.
  * Fix CVE-2025-67269 (Closes: #1124799).
    An integer underflow vulnerability exists in the `nextstate()`
    function in `gpsd/packet.c`.
    When parsing a NAVCOM packet, the payload length is calculated
    using `lexer->length = (size_t)c - 4` without checking if
    the input byte `c` is less than 4. This results in an unsigned
    integer underflow, setting `lexer->length` to a very large value
    (near `SIZE_MAX`). The parser then enters a loop attempting to
    consume this massive number of bytes, causing 100% CPU utilization
    and a Denial of Service (DoS) condition.

 -- Bastien Roucariès <rouca@debian.org>  Sat, 17 Jan 2026 16:47:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gpsd
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Boian Bonev <bbonev@ipacct.com>
+Maintainer: Boian Bonev <bbonev@ipacct.com>
 Build-Depends:
  debhelper-compat (= 13),
  dh-apparmor,
